Перейти к основному содержимому

dhtmlxScheduler with Angular

примечание

This tutorial shows how to use the JS DHTMLX Scheduler directly in an Angular app without the official wrapper.

If you want Angular inputs/outputs, wrapper-managed sync, and Angular template component support, use Angular Scheduler instead.

You should be familiar with basic Angular concepts (components, lifecycle hooks, services). If not, start with the Angular documentation.

DHTMLX Scheduler is compatible with Angular. You can check the related demo repository on GitHub: DHTMLX Scheduler with Angular Demo.

Creating a project​

Before you start, install Node.js and Angular CLI.

ng new my-angular-scheduler-app --standalone --routing=false --style=css
cd my-angular-scheduler-app

Start the app once to verify the project is working:

  • npm: npm start
  • yarn: yarn start
  • or CLI: ng serve

The app should be available at http://localhost:4200.

Scheduler with Angular

Creating Scheduler​

Now we should get the DHTMLX Scheduler code. Firstly, we need to stop the app by pressing Ctrl+C in the command line. Then we can proceed with installing the Scheduler package.

Step 1. Package installation​

The PRO versions of the library are available for the npm/yarn install from our private repository, please follow this instruction to gain access to it.

After you've got the Evaluation version of the Scheduler, you can install it with the following commands:

  • for npm:
npm install @dhx/trial-scheduler
  • for yarn:
yarn add @dhx/trial-scheduler

Alternatively, since the zip-package of the library is structured as an npm module, you can install it from a local folder.

Step 2. Component creation​

Now we should create a component to add a Scheduler into the application. Let's create the scheduler folder in the src/app/ directory, add new files into it and call them scheduler.component.ts, scheduler.component.css and scheduler.component.html.

The newly created scheduler.component.html file inside the scheduler folder will contain the template for the scheduler. Let's add the following lines of code into it:

scheduler/scheduler.component.html
<div #scheduler_here style="width: 100%; height:100vh"></div>

We'll declare scheduler styles in a separate file named scheduler.component.css. The default styles can look like this:

scheduler/scheduler.component.css
@import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";
:host {
display: block;
position: relative;
height: 100%;
width: 100%;
}

To make the Scheduler container occupy the entire space of the body, you need to add the following styles to the styles.css file located in the src folder:

src/styles.css
html,
body {
margin: 0;
padding: 0;
height: 100%;
width: 100%;
}

Importing source files​

Open the scheduler.component.ts and scheduler.component.css files and import Scheduler source files. Note that:

  • if you've installed the Scheduler package from a local folder, your import paths will look like this:
scheduler.component.ts
import { Scheduler, SchedulerStatic } from 'dhtmlx-scheduler';
scheduler.component.css
@import "@dhtmlx-scheduler/codebase/dhtmlxscheduler.css";
  • if you've chosen to install the trial version, the import paths should be as in:
scheduler.component.ts
import { Scheduler, SchedulerStatic } from '@dhx/trial-scheduler';
scheduler.component.css
@import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";

In this tutorial we will use the trial version of Scheduler.

Setting the container and adding Scheduler​

To display Scheduler on the page, we need to set the container to render the component inside. Use the code below:

scheduler.component.ts
import { Scheduler, SchedulerStatic } from "@dhx/trial-scheduler";
import { Component, ElementRef, OnInit, OnDestroy,
ViewChild, ViewEncapsulation } from "@angular/core";

@Component({
encapsulation: ViewEncapsulation.None,
selector: "scheduler",
styleUrls: ["./scheduler.component.css"],
templateUrl: 'scheduler.component.html'
})

export class SchedulerComponent implements OnInit, OnDestroy {
@ViewChild("scheduler_here", { static: true }) schedulerContainer!: ElementRef;
private _scheduler?: SchedulerStatic;

ngOnInit() {
let scheduler = Scheduler.getSchedulerInstance();
scheduler.init(
this.schedulerContainer.nativeElement,
new Date(2027, 9, 7),
"week",
);
this._scheduler = scheduler;
}

ngOnDestroy() {
if (this._scheduler) this._scheduler.destructor();
}
}

In the above code we've used the ngOnInit() method of Angular and also specified the ngOnDestroy() method that contains the scheduler.destructor() call to clear the component when it is no longer needed.

Step 3. Adding Scheduler into the app​

Now it's time to add the component into our app. Open src/app/app.ts and use the Scheduler Component instead of the default content by inserting the code below:

src/app/app.ts
import { Component } from '@angular/core';

@Component({
selector: 'app-root',
template: `<scheduler></scheduler>`,
})
export class App {}

After that, when we start the app by using:

ng serve

We should see an empty Scheduler on a page.

Adding Scheduler into an app

Step 4. Providing Data​

Create src/app/demo-data.ts with a small dataset:

export function getData() {
return [
{
id: 1,
start_date: new Date('2027-10-06T02:00:00Z'),
end_date: new Date('2027-10-06T10:20:00Z'),
text: 'Product Strategy Hike',
},
{
id: 2,
start_date: new Date('2027-10-07T12:00:00Z'),
end_date: new Date('2027-10-07T16:00:00Z'),
text: 'Agile Meditation and Release',
},
{
id: 3,
start_date: new Date('2027-10-07T06:00:00Z'),
end_date: new Date('2027-10-07T11:00:00Z'),
text: 'Tranquil Tea Time',
},
];
}

Now import and parse the data in Scheduler component:

src/app/scheduler/scheduler.component.ts
import { getData } from '../demo-data';

...
let scheduler = Scheduler.getSchedulerInstance();
scheduler.init(
this.schedulerContainer.nativeElement,
new Date(2027, 9, 7),
"week",
);
scheduler.parse(getData());
this._scheduler = scheduler;

Now, if you reopen the app page, you should see a Scheduler with events.

Scheduler with Angular events

Step 5. Saving Data​

To capture changes made in the Scheduler, you can use a dataProcessor handler that lets you "communicate" with the server-side backend. The handler can be declared either as a function or a router object. dhtmlxScheduler accepts Promise response from the handler, so your Scheduler will correctly process the completion of an action.

You can create a DataProcessor via the createDataProcessor() API method and capture changes, like this:

scheduler.createDataProcessor(function(entity, action, data, id) {​
scheduler.message(`${​entity} ${​action}`);
});

If your service changes the event id after creating a new record (which it usually does), make sure that your Promise returns an object with (id: databaseId) or (tid: databaseId) as a result, so that Scheduler could apply the new database id to the record. Get more information about the server side.

Well, Angular Scheduler is ready, you are welcome to check out the full demo on GitHub.

XSS, CSRF and SQL Injection Attacks​

Pay attention that Scheduler doesn't provide any means of preventing an application from various threats, such as SQL injections or XSS and CSRF attacks. It is important that responsibility for keeping an application safe is on the developers implementing the backend.

Check the Application Security article to learn the most vulnerable points of the component and the measures you can take to improve the safety of your application.

Need help?
Got a question about the documentation? Reach out to our technical support team for help and guidance. For custom component solutions, visit the Services page.

Перейти к основному содержимому

dhtmlxScheduler with Vue.js

примечание

This tutorial shows how to use the JS DHTMLX Scheduler package directly in a Vue app without the official wrapper.

If you want Vue props/events, wrapper-managed sync, and wrapper composables, use Vue Scheduler instead.

This page is for low-level integration. You initialize and manage the Scheduler instance yourself.

Prerequisites​

  • Node.js installed
  • Basic Vue 3 knowledge (components, refs, lifecycle hooks)
  • A Vue 3 project (this tutorial shows how to create one with Vite)

Create A Vue Project​

Create a Vue 3 app with Vite:

npm create vue@latest scheduler-vue-app
cd scheduler-vue-app

Install dependencies and start the dev server once to confirm the project works:

  • npm:
npm install
npm run dev
  • yarn:
yarn install
yarn dev

You should now have your Vue project running on http://localhost:5173.

Scheduler Vue.js app running

Creating Scheduler​

Now we should get the DHTMLX Scheduler code. Firstly, we need to stop the app by pressing Ctrl+C in the command line. Then we can proceed with installing the Scheduler package.

Step 1. Package installation​

The PRO versions of the library are available for the npm/yarn install from our private repository, please follow this instruction to gain access to it.

After you've got the Evaluation version of the Scheduler, you can install it with the following commands:

  • for npm:
npm install @dhx/trial-scheduler
  • for yarn:
yarn add @dhx/trial-scheduler

Alternatively, since the zip-package of the library is structured as an npm module, you can install it from a local folder.

Step 2. Component creation​

Now we should create a Vue component, to add a Scheduler into the application. Let's create a new file in the src/components/ directory and name it Scheduler.vue.

Importing source files​

Open the newly created Scheduler.vue file and import Scheduler source files. Note that:

  • if you've installed the Scheduler package from a local folder, your import paths will look like this:
Scheduler.vue
import { Scheduler } from "dhtmlx-scheduler";
…
<style>
@import "@dhtmlx-scheduler/codebase/dhtmlxscheduler.css";
</style>
  • if you've chosen to install the trial version, the import paths should be as in:
Scheduler.vue
import { Scheduler } from "@dhx/trial-scheduler";
…
<style>
@import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";
</style>

In this tutorial we will use the trial version of Scheduler.

Setting the container and adding Scheduler​

To display Scheduler on the page, we need to set the container to render the component inside. Check the code below:

Scheduler.vue
<script>
import { Scheduler } from "@dhx/trial-scheduler";
import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";

export default {
mounted() {
let scheduler = Scheduler.getSchedulerInstance();
let date = scheduler.init(this.$refs.cont, new Date(2026, 9, 6), "week");
this.scheduler = scheduler;
},
unmounted() {
this.scheduler.destructor();
this.$refs.cont.innerHTML = "";
},
};
</script>

<template>
<div ref="cont" style="width: 100%; height: 100vh"></div>
</template>

To make the Scheduler container occupy the entire space of the body, you need to remove the default styles from the main.css file located in the src/assets folder and add the following one:

src/assets/main.css
#app {
margin: 0;
padding: 0;
height: 100%;
width: 100%;
}

Step 3. Adding Scheduler into the app​

Now it's time to add the component into our app. Open src/App.vue and use the Scheduler component instead of the default content by inserting the code below:

src/App.vue
<script>
import Scheduler from "./components/Scheduler.vue";

export default {
components: { Scheduler },
};
</script>

<template>
<Scheduler/>
</template>

After that, when we start the app, we should see an empty Scheduler on a page:

Scheduler Vue init

Step 4. Providing Data​

To add data into the Scheduler, we need to provide a data set. Let's create the data.js file in the src/ directory and add some data into it:

src/data.js
export function getData() {
const data = [
{
start_date: "2026-06-10 6:00",
end_date: "2026-06-10 8:00",
text: "Event 1",
id: 1,
},
{
start_date: "2026-06-13 10:00",
end_date: "2026-06-13 18:00",
text: "Event 2",
id: 2,
},
];
return data;
}

We should pass props (our data) to a Scheduler component in App.vue:

App.vue
<script>
import Scheduler from "./components/Scheduler.vue";
import { getData } from "./data";

export default {
components: { Scheduler },
data() {
return {
events: getData(),
};
},
};
</script>

<template>
<Scheduler :events="events" />
</template>

And then use props in the scheduler.parse() method in the Scheduler component:

Scheduler.vue
<script>
import { Scheduler } from "@dhx/trial-scheduler";
import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";

export default {
props: ["events"],
mounted() {
let scheduler = Scheduler.getSchedulerInstance();
let date = scheduler.init(this.$refs.cont, new Date(2026, 5, 10), "week");
scheduler.parse(this.events);

this.scheduler = scheduler;
},
unmounted() {
this.scheduler.destructor();
this.$refs.cont.innerHTML = "";
},
};
</script>

<template>
<div ref="cont" style="width: 100%; height: 100vh"></div>
</template>

Now, if you reopen the app page, you should see a Scheduler with events:

Scheduler Vue events

Step 5. Saving Data​

To capture changes made in the Scheduler, you can use the dataProcessor handler that lets you "communicate" with the server-side backend. The handler can be declared either as a function or as a router object. dhtmlxScheduler accepts Promise response from the handler, so your Scheduler will correctly process the completion of an action.

You can create a DataProcessor via the createDataProcessor() API method and capture changes like this:

scheduler.createDataProcessor(function(entity, action, data, id) {​
scheduler.message(`${​entity} ${​action}`);
});

If your service changes the event id after creating a new record (which it usually does), make sure that your Promise returns an object with (id: databaseId) or (tid: databaseId) as a result, so Scheduler could apply the new database id to the record. Get more information about the server side.

Well, Vue Scheduler is ready, you are welcome to check out the full demo on GitHub.

XSS, CSRF and SQL Injection Attacks​

Pay attention that Scheduler doesn't provide any means of preventing an application from various threats, such as SQL injections or XSS and CSRF attacks. It is important that responsibility for keeping an application safe is on the developers implementing the backend.

Check the Application Security article to learn the most vulnerable points of the component and the measures you can take to improve the safety of your application.

Need help?
Got a question about the documentation? Reach out to our technical support team for help and guidance. For custom component solutions, visit the Services page.

Перейти к основному содержимому

dhtmlxScheduler с React

Вам следует быть знакомым с базовыми концепциями и шаблонами React, чтобы пользоваться этой документацией.
Если нет, ознакомьтесь с React документацией для введения в работу.

DHTMLX Scheduler совместим с React. Вы можете увидеть соответствующий пример на GitHub: DHTMLX Scheduler with React Demo.

Создание проекта​

Перед началом убедитесь, что у вас установлен Node.js.

Вы можете создать базовый проект React с помощью следующей команды:

npx create-vite my-react-scheduler-app --template react

Установка зависимостей​

Далее перейдите в директорию приложения. Назовём наш проект my-react-scheduler-app и запустим:

cd my-react-scheduler-app

После этого нужно установить зависимости и запустить dev-сервер. Для этого используйте менеджер пакетов:

  • если вы используете yarn, выполните следующие команды:
yarn install
yarn dev
  • если же вы пользуетесь npm, выполните следующие команды:
npm install
npm run dev

Теперь ваше приложение на React должно работать на http://localhost:5173.

Scheduler React app running

Создание Scheduler​

Теперь нужно получить код DHTMLX Scheduler. Сначала остановим приложение, нажав Ctrl+C в командной строке. Затем можно приступить к установке пакета Scheduler.

Шаг 1. Установка пакета​

ПРО-версии библиотеки доступны для установки через npm/yarn из нашего приватного репозитория, пожалуйста, следуйте
данной инструкции чтобы получить доступ к нему.

После того как вы получите Evaluation-версию Scheduler, вы можете установить её следующими командами:

  • для npm:
npm install @dhx/trial-scheduler
  • для yarn:
yarn add @dhx/trial-scheduler

Либо, поскольку zip-пакет библиотеки структурирован как модуль npm, вы можете установить его из локальной папки.

Шаг 2. Создание компонента​

Теперь нужно создать React-компонент, чтобы добавить Scheduler в приложение. Давайте создадим папку src/components/Scheduler.
Здесь мы создадим файлы Scheduler.jsx, Scheduler.css и index.js.

Необходимо создать файл Scheduler.css и добавить стили для scheduler-container:

src/components/Scheduler/Scheduler.css
.scheduler-container {
height: 100vh;
width: 100vw;
}

Чтобы Scheduler занимал всё пространство body, нужно убрать стандартные стили из файла App.css, который расположен в папке src, и добавить следующие:

#root {
margin: 0;
padding: 0;
height: 100%;
width: 100%;
}

И добавить файл index.js со следующим содержимым:

src/components/Scheduler/index.js
import Scheduler from './Scheduler';
import './Scheduler.css';
export default Scheduler;

Импорт исходников​

Откройте только что созданный файл Scheduler.jsx и импортируйте исходники Scheduler. Обратите внимание, что:

  • если вы установили пакет Scheduler из локальной папки, ваши пути импорта будут выглядеть так:
Scheduler.jsx
import { Scheduler } from 'dhtmlx-scheduler';
import 'dhtmlx-scheduler/codebase/dhtmlxscheduler.css';
  • если вы выбрали установить пробную версию, пути импорта должны быть как в примере:
Scheduler.jsx
import { Scheduler } from '@dhx/trial-scheduler';
import '@dhx/trial-scheduler/codebase/dhtmlxscheduler.css';

В этом руководстве мы будем использовать пробную версию Scheduler.

Установка контейнера и добавление Scheduler​

Чтобы отобразить Scheduler на странице, нужно задать контейнер, в который будет отрисовываться компонент. Создайте файл Scheduler.jsx со следующим кодом:

src/components/Scheduler/Scheduler.jsx
import { useEffect, useRef } from "react";
import { Scheduler } from "@dhx/trial-scheduler";
import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";

export default function SchedulerView( ) {
let container = useRef();
useEffect(() => {
let scheduler = Scheduler.getSchedulerInstance();
scheduler.skin = "terrace";
scheduler.config.header = [
"day",
"week",
"month",
"date",
"prev",
"today",
"next",
];

scheduler.init(container.current, new Date(2024, 5, 10));
return () => {
scheduler.destructor();
container.current.innerHTML = "";
};
}, []);

return (
<div ref="{container}" style={{}} width: "100%", height: "100%" }}></div>
);
}

Шаг 3. Добавление Scheduler в приложение​

Теперь пора добавить компонент в наше приложение. Откройте src/App.jsx и используйте компонент Scheduler вместо стандартного содержимого, вставив код ниже:

src/App.jsx
import Scheduler from "./components/Scheduler";
import "./App.css";

function App() {
return (
<div className="scheduler-container">
<Scheduler/>
</div>
);
}
export default App;

После этого, при запуске приложения, вы увидите пустой Scheduler на странице:

Scheduler React init

Шаг 4. Предоставление данных​

Чтобы добавить данные в Scheduler, необходимо предоставить набор данных. Давайте создадим файл data.js в директории src/ и добавим в него данные:

src/data.js
export function getData() {
const data = [
{
start_date: "2024-06-10 6:00",
end_date: "2024-06-10 8:00",
text: "Event 1",
id: 1,
},
{
start_date: "2024-06-13 10:00",
end_date: "2024-06-13 18:00",
text: "Event 2",
id: 2,
},
];
return data;
}

И следует передать props (наши данные) в компонент Scheduler в App.jsx:

App.jsx
import { getData } from "./data.js";
import Scheduler from "./components/Scheduler";
import "./App.css";

function App() {
return (
<div className="scheduler-container">
<Scheduler events="{getData()}/">
</div>
);
}
export default App;

И используйте props в методе scheduler.parse() внутри Scheduler-компонтента:

Scheduler.jsx
import { useEffect, useRef } from "react";
import { Scheduler } from "@dhx/trial-scheduler";
import "@dhx/trial-scheduler/codebase/dhtmlxscheduler.css";

export default function SchedulerView({events}) {
let container = useRef();
useEffect(() => {
let scheduler = Scheduler.getSchedulerInstance();
scheduler.skin = "terrace";
scheduler.config.header = [
"day",
"week",
"month",
"date",
"prev",
"today",
"next",
];

scheduler.init(container.current, new Date(2024, 5, 10));
scheduler.parse(events);
return () => {
scheduler.destructor();
container.current.innerHTML = "";
};
}, []);

return (
<div ref="{container}" style={{}} width: "100%", height: "100%" }}></div>
);
}

Теперь, если вы снова откроете страницу приложения, вы увидите Scheduler с событиями:

Scheduler React events

Шаг 5. Сохранение данных​

Чтобы зафиксировать изменения, внесённые в Scheduler, можно использовать обработчик dataProcessor, который позволяет «общаться» с серверной частью. Обработчик можно объявлять либо как функцию, либо как router-объект.
dhtmlxScheduler принимает ответ Promise от обработчика, поэтому ваш Scheduler корректно обработает завершение действия.

Вы можете создать DataProcessor через API-метод createDataProcessor() и зафиксировать изменения вот так:

scheduler.createDataProcessor(function(entity, action, data, id) {​
scheduler.message(`${​entity} ${​action}`);
});

Если ваш сервис изменяет id события после создания новой записи (что обычно так и происходит), убедитесь, что ваш Promise возвращает объект вида (id: databaseId) или (tid: databaseId) в качестве результата, чтобы Scheduler мог применить новый идентификатор базы данных к запиcи. Узнать более подробную информацию о серверной стороне.

Итак, React Scheduler готов, добро пожаловать посмотреть полную демонстрацию на GitHub: DHTMLX Scheduler with React Demo.

XSS, CSRF и SQL-инъекции​

Обратите внимание, что Scheduler не предоставляет средств для предотвращения угроз в приложении, таких как инъекции SQL или атаки XSS и CSRF. Важно, чтобы ответственность за безопасность приложения лежала на разработчиках, реализующих backend.

Ознакомьтесь со статьёй Application Security, чтобы узнать наиболее уязвимые точки компонента и меры по улучшению безопасности вашего приложения.

Need help?
Got a question about the documentation? Reach out to our technical support team for help and guidance. For custom component solutions, visit the Services page.